#include "SceneLib.h"


Scene *P1_Model2World(Scene* scene1)
{
   // Walk the list of Triangle objects.
   // For each Vertex in each Triangle object,
   // use the Scene's model matrix to transform
   // the Vertex object to model coordinates.

   Scene *scene2 = new Scene(); // we need a new Scene object
   // copy information from scene1 to scene2
   for (int i = 0; i < scene1->textureCount; i++)
   {
      scene2->textures[i] = scene1->textures[i];
   }
   scene2->textureCount = scene1->textureCount;
   scene2->bilerp_flag = scene1->bilerp_flag;
   scene2->light = scene1->light;
   scene2->vp_width = scene1->vp_width;
   scene2->vp_height = scene1->vp_height;
   scene2->projection = scene1->projection;
   scene2->model = scene1->model;
   scene2->view = scene1->view;

   TriangleListNode *ptr;  // use this pointer to walk a scene's list of triangles

   /* copy each Triangle object in the list from scene1 into the list for scene2 */
   for (ptr = (scene1->head_node).next;  ptr;  ptr = ptr->next)
   {
      Triangle* newT = new Triangle( (ptr->t->v)+0, (ptr->t->v)+1, (ptr->t->v)+2 );
      newT->tex = ptr->t->tex;
      newT->mtrl = ptr->t->mtrl;
      scene2->addTriangle( newT );
   }

   /* transform each Triangle object in the list from scene2 */
   for (ptr = (scene2->head_node).next;  ptr;  ptr = ptr->next)
   {
      Matrix m = scene2->model;
      ptr->t->v[0] = m.times( ptr->t->v[0] );
      ptr->t->v[1] = m.times( ptr->t->v[1] );
      ptr->t->v[2] = m.times( ptr->t->v[2] );
   }

   return scene2;
}
