#include "SceneLib.h"

Scene *P6_PerspDiv(Scene* scene)
{
   // Walk the list of Triangle objects and
   // divide each of the coordinates in a
   // vertex by its w coordinate, i.e.,
   // (x, y, z, w) -> (x/w, y/w, z/w, 1).

   TriangleListNode *ptr;  // use this pointer to walk the scene's list of triangles

   /* transform each Triangle object in the list */
   for (ptr = (scene->head_node).next;  ptr;  ptr = ptr->next)
   {
      ptr->t->v[0] = (ptr->t->v[0]).times( 1.0/(ptr->t->v[0].w) );
      ptr->t->v[1] = (ptr->t->v[1]).times( 1.0/(ptr->t->v[1].w) );
      ptr->t->v[2] = (ptr->t->v[2]).times( 1.0/(ptr->t->v[2].w) );
   }

   return scene;
}
