#include <stdio.h>
#include "SceneRender.h"

void printVertices(Scene *s);


void renderScene(Scene *s1, FrameBuffer *fb)
{
   #if DEBUG1==1
      printVertices(s1);
   #endif

   Scene *s2 = P1_Model2World(s1); // apply the model transformation

   #if DEBUG1==2
      printVertices(s2);
   #endif

   Scene *s3 = P2_Lighting(s2);    // compute vertex shading

   #if DEBUG1==3
      printVertices(s3);
   #endif

   Scene *s4 = P3_World2View(s3);  // apply the view transformation

   #if DEBUG1==4
      printVertices(s4);
   #endif

   Scene *s5 = P4_View2Clip(s4);   // apply the projection transformation

   #if DEBUG1==5
      printVertices(s5);
   #endif

   Scene *s6 = P5_Clip(s5);        // clip triangles to the standard volume

   #if DEBUG1==6
      printVertices(s6);
   #endif

   Scene *s7 = P6_PerspDiv(s6);    // transform to normalized divice coordinates

   #if DEBUG1==7
      printVertices(s7);
   #endif

   P7_fake(s7);                    // let OpenGL finish the pipeline

//   FB(fb);                         // test the framebuffer

   delete s2;

   return;
}//renderScene()


#if DEBUG1
void printVertices(Scene *s)
{
   TriangleListNode *ptr;
   fprintf(stderr, "================= Stage P%d begin ===========\n", DEBUG1-1);
   for (ptr = (s->head_node).next;  ptr;  ptr = ptr->next)
   {
      fprintf(stderr, "[% .6f % .6f % .6f % .6f]\n",
                        ptr->t->v[0].x, ptr->t->v[0].y, ptr->t->v[0].z, ptr->t->v[0].w );
      fprintf(stderr, "{% .6f % .6f % .6f % .6f}\n",
                        ptr->t->v[1].x, ptr->t->v[1].y, ptr->t->v[1].z, ptr->t->v[1].w );
      fprintf(stderr, "<% .6f % .6f % .6f % .6f>\n",
                        ptr->t->v[2].x, ptr->t->v[2].y, ptr->t->v[2].z, ptr->t->v[2].w );
      fflush(stderr);
   }
   fprintf(stderr, "================= Stage P%d end =============\n", DEBUG1-1);
}
 #endif